# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class V2Fasta(str, Enum):
    """
    V2Fasta
    """

    """
    allowed enum values
    """
    FASTA_UNSPECIFIED = 'FASTA_UNSPECIFIED'
    FASTA_GENE = 'FASTA_GENE'
    FASTA_RNA = 'FASTA_RNA'
    FASTA_PROTEIN = 'FASTA_PROTEIN'
    FASTA_GENE_FLANK = 'FASTA_GENE_FLANK'
    FASTA_CDS = 'FASTA_CDS'
    FASTA_5_P_UTR = 'FASTA_5P_UTR'
    FASTA_3_P_UTR = 'FASTA_3P_UTR'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of V2Fasta from a JSON string"""
        return cls(json.loads(json_str))


