# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ncbi.datasets.openapi.models.v2reports_error_assembly_error_code import V2reportsErrorAssemblyErrorCode
from ncbi.datasets.openapi.models.v2reports_error_gene_error_code import V2reportsErrorGeneErrorCode
from ncbi.datasets.openapi.models.v2reports_error_organelle_error_code import V2reportsErrorOrganelleErrorCode
from ncbi.datasets.openapi.models.v2reports_error_taxonomy_error_code import V2reportsErrorTaxonomyErrorCode
from ncbi.datasets.openapi.models.v2reports_error_virus_error_code import V2reportsErrorVirusErrorCode
from typing import Optional, Set
from typing_extensions import Self

class V2reportsError(BaseModel):
    """
    V2reportsError
    """ # noqa: E501
    assembly_error_code: Optional[V2reportsErrorAssemblyErrorCode] = None
    gene_error_code: Optional[V2reportsErrorGeneErrorCode] = None
    organelle_error_code: Optional[V2reportsErrorOrganelleErrorCode] = None
    virus_error_code: Optional[V2reportsErrorVirusErrorCode] = None
    taxonomy_error_code: Optional[V2reportsErrorTaxonomyErrorCode] = None
    reason: Optional[StrictStr] = None
    message: Optional[StrictStr] = None
    invalid_identifiers: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["assembly_error_code", "gene_error_code", "organelle_error_code", "virus_error_code", "taxonomy_error_code", "reason", "message", "invalid_identifiers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V2reportsError from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V2reportsError from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assembly_error_code": obj.get("assembly_error_code"),
            "gene_error_code": obj.get("gene_error_code"),
            "organelle_error_code": obj.get("organelle_error_code"),
            "virus_error_code": obj.get("virus_error_code"),
            "taxonomy_error_code": obj.get("taxonomy_error_code"),
            "reason": obj.get("reason"),
            "message": obj.get("message"),
            "invalid_identifiers": obj.get("invalid_identifiers")
        })
        return _obj


