# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ncbi.datasets.openapi.models.v2reports_range import V2reportsRange
from typing import Optional, Set
from typing_extensions import Self

class V2reportsGenomicLocation(BaseModel):
    """
    V2reportsGenomicLocation
    """ # noqa: E501
    genomic_accession_version: Optional[StrictStr] = None
    sequence_name: Optional[StrictStr] = None
    genomic_range: Optional[V2reportsRange] = None
    exons: Optional[List[V2reportsRange]] = None
    __properties: ClassVar[List[str]] = ["genomic_accession_version", "sequence_name", "genomic_range", "exons"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V2reportsGenomicLocation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of genomic_range
        if self.genomic_range:
            _dict['genomic_range'] = self.genomic_range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in exons (list)
        _items = []
        if self.exons:
            for _item_exons in self.exons:
                if _item_exons:
                    _items.append(_item_exons.to_dict())
            _dict['exons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V2reportsGenomicLocation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "genomic_accession_version": obj.get("genomic_accession_version"),
            "sequence_name": obj.get("sequence_name"),
            "genomic_range": V2reportsRange.from_dict(obj["genomic_range"]) if obj.get("genomic_range") is not None else None,
            "exons": [V2reportsRange.from_dict(_item) for _item in obj["exons"]] if obj.get("exons") is not None else None
        })
        return _obj


