# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class V2reportsRankType(str, Enum):
    """
    V2reportsRankType
    """

    """
    allowed enum values
    """
    NO_RANK = 'NO_RANK'
    SUPERKINGDOM = 'SUPERKINGDOM'
    DOMAIN = 'DOMAIN'
    REALM = 'REALM'
    KINGDOM = 'KINGDOM'
    SUBKINGDOM = 'SUBKINGDOM'
    SUPERPHYLUM = 'SUPERPHYLUM'
    SUBPHYLUM = 'SUBPHYLUM'
    PHYLUM = 'PHYLUM'
    CLADE = 'CLADE'
    SUPERCLASS = 'SUPERCLASS'
    CLASS = 'CLASS'
    SUBCLASS = 'SUBCLASS'
    INFRACLASS = 'INFRACLASS'
    COHORT = 'COHORT'
    SUBCOHORT = 'SUBCOHORT'
    SUPERORDER = 'SUPERORDER'
    ORDER = 'ORDER'
    SUBORDER = 'SUBORDER'
    INFRAORDER = 'INFRAORDER'
    PARVORDER = 'PARVORDER'
    SUPERFAMILY = 'SUPERFAMILY'
    FAMILY = 'FAMILY'
    SUBFAMILY = 'SUBFAMILY'
    GENUS = 'GENUS'
    SUBGENUS = 'SUBGENUS'
    SPECIES_GROUP = 'SPECIES_GROUP'
    SPECIES_SUBGROUP = 'SPECIES_SUBGROUP'
    SPECIES = 'SPECIES'
    SUBSPECIES = 'SUBSPECIES'
    TRIBE = 'TRIBE'
    SUBTRIBE = 'SUBTRIBE'
    FORMA = 'FORMA'
    VARIETAS = 'VARIETAS'
    STRAIN = 'STRAIN'
    SECTION = 'SECTION'
    SUBSECTION = 'SUBSECTION'
    PATHOGROUP = 'PATHOGROUP'
    SUBVARIETY = 'SUBVARIETY'
    GENOTYPE = 'GENOTYPE'
    SEROTYPE = 'SEROTYPE'
    ISOLATE = 'ISOLATE'
    MORPH = 'MORPH'
    SERIES = 'SERIES'
    FORMA_SPECIALIS = 'FORMA_SPECIALIS'
    SEROGROUP = 'SEROGROUP'
    BIOTYPE = 'BIOTYPE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of V2reportsRankType from a JSON string"""
        return cls(json.loads(json_str))


