# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from ncbi.datasets.openapi.api.gene_api import GeneApi


class TestGeneApi(unittest.TestCase):
    """GeneApi unit test stubs"""

    def setUp(self) -> None:
        self.api = GeneApi()

    def tearDown(self) -> None:
        pass

    def test_download_gene_package(self) -> None:
        """Test case for download_gene_package

        Get a gene dataset by gene ID
        """
        pass

    def test_download_gene_package_post(self) -> None:
        """Test case for download_gene_package_post

        Get a gene dataset by POST
        """
        pass

    def test_gene_chromosome_summary(self) -> None:
        """Test case for gene_chromosome_summary

        Get summary of chromosomes for a particular taxon's annotation
        """
        pass

    def test_gene_counts_for_taxon(self) -> None:
        """Test case for gene_counts_for_taxon

        Get gene counts by taxonomic identifier
        """
        pass

    def test_gene_counts_for_taxon_by_post(self) -> None:
        """Test case for gene_counts_for_taxon_by_post

        Get gene counts by taxonomic identifier
        """
        pass

    def test_gene_dataset_report(self) -> None:
        """Test case for gene_dataset_report

        Get gene dataset report as JSON
        """
        pass

    def test_gene_dataset_report_by_accession(self) -> None:
        """Test case for gene_dataset_report_by_accession

        Get dataset reports by accession IDs
        """
        pass

    def test_gene_dataset_report_by_tax_and_symbol(self) -> None:
        """Test case for gene_dataset_report_by_tax_and_symbol

        Get dataset reports by taxons.
        """
        pass

    def test_gene_dataset_reports_by_id(self) -> None:
        """Test case for gene_dataset_reports_by_id

        Get dataset reports by gene IDs.
        """
        pass

    def test_gene_dataset_reports_by_locus_tag(self) -> None:
        """Test case for gene_dataset_reports_by_locus_tag

        Get gene dataset reports by locus tag
        """
        pass

    def test_gene_dataset_reports_by_taxon(self) -> None:
        """Test case for gene_dataset_reports_by_taxon

        Get gene dataset reports by taxonomic identifier
        """
        pass

    def test_gene_download_summary_by_id(self) -> None:
        """Test case for gene_download_summary_by_id

        Get gene download summary by GeneID
        """
        pass

    def test_gene_download_summary_by_post(self) -> None:
        """Test case for gene_download_summary_by_post

        Get gene download summary
        """
        pass

    def test_gene_links_by_id(self) -> None:
        """Test case for gene_links_by_id

        Get gene links by gene ID
        """
        pass

    def test_gene_links_by_id_by_post(self) -> None:
        """Test case for gene_links_by_id_by_post

        Get gene links by gene ID
        """
        pass

    def test_gene_metadata_by_accession(self) -> None:
        """Test case for gene_metadata_by_accession

        Get gene metadata by RefSeq Accession
        """
        pass

    def test_gene_metadata_by_post(self) -> None:
        """Test case for gene_metadata_by_post

        Get gene metadata as JSON
        """
        pass

    def test_gene_metadata_by_tax_and_symbol(self) -> None:
        """Test case for gene_metadata_by_tax_and_symbol

        Get gene metadata by gene symbol
        """
        pass

    def test_gene_orthologs_by_id(self) -> None:
        """Test case for gene_orthologs_by_id

        Get gene orthologs by gene ID
        """
        pass

    def test_gene_orthologs_by_post(self) -> None:
        """Test case for gene_orthologs_by_post

        Get gene orthologs by gene ID
        """
        pass

    def test_gene_product_report(self) -> None:
        """Test case for gene_product_report

        Get gene product reports as JSON
        """
        pass

    def test_gene_product_report_by_accession(self) -> None:
        """Test case for gene_product_report_by_accession

        Get gene product reports by accession IDs
        """
        pass

    def test_gene_product_report_by_tax_and_symbol(self) -> None:
        """Test case for gene_product_report_by_tax_and_symbol

        Get product reports by taxon.
        """
        pass

    def test_gene_product_reports_by_id(self) -> None:
        """Test case for gene_product_reports_by_id

        Get gene product reports by gene IDs.
        """
        pass

    def test_gene_product_reports_by_locus_tags(self) -> None:
        """Test case for gene_product_reports_by_locus_tags

        Get gene product reports by locus tags
        """
        pass

    def test_gene_product_reports_by_taxon(self) -> None:
        """Test case for gene_product_reports_by_taxon

        Get gene product reports by taxonomic identifier
        """
        pass

    def test_gene_reports_by_id(self) -> None:
        """Test case for gene_reports_by_id

        Get gene reports by GeneID
        """
        pass

    def test_gene_reports_by_taxon(self) -> None:
        """Test case for gene_reports_by_taxon

        Get gene reports by taxonomic identifier
        """
        pass


if __name__ == '__main__':
    unittest.main()
