# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from ncbi.datasets.openapi.api.genome_api import GenomeApi


class TestGenomeApi(unittest.TestCase):
    """GenomeApi unit test stubs"""

    def setUp(self) -> None:
        self.api = GenomeApi()

    def tearDown(self) -> None:
        pass

    def test_annotation_report_facets_by_accession(self) -> None:
        """Test case for annotation_report_facets_by_accession

        Get genome annotation report summary information
        """
        pass

    def test_annotation_report_facets_by_post(self) -> None:
        """Test case for annotation_report_facets_by_post

        Get genome annotation report summary information
        """
        pass

    def test_assembly_accessions_for_sequence_accession(self) -> None:
        """Test case for assembly_accessions_for_sequence_accession

        Get assembly accessions for a sequence accession
        """
        pass

    def test_assembly_accessions_for_sequence_accession_by_post(self) -> None:
        """Test case for assembly_accessions_for_sequence_accession_by_post

        Get assembly accessions for a sequence accession
        """
        pass

    def test_assembly_revision_history_by_get(self) -> None:
        """Test case for assembly_revision_history_by_get

        Get revision history for assembly by accession
        """
        pass

    def test_assembly_revision_history_by_post(self) -> None:
        """Test case for assembly_revision_history_by_post

        Get revision history for assembly by accession
        """
        pass

    def test_check_assembly_availability(self) -> None:
        """Test case for check_assembly_availability

        Check the validity of genome accessions
        """
        pass

    def test_check_assembly_availability_post(self) -> None:
        """Test case for check_assembly_availability_post

        Check the validity of many genome accessions in a single request
        """
        pass

    def test_checkm_histogram_by_taxon(self) -> None:
        """Test case for checkm_histogram_by_taxon

        Get CheckM histogram by species taxon
        """
        pass

    def test_checkm_histogram_by_taxon_by_post(self) -> None:
        """Test case for checkm_histogram_by_taxon_by_post

        Get CheckM histogram by species taxon
        """
        pass

    def test_download_assembly_package(self) -> None:
        """Test case for download_assembly_package

        Get a genome dataset by accession
        """
        pass

    def test_download_assembly_package_post(self) -> None:
        """Test case for download_assembly_package_post

        Get a genome dataset by post
        """
        pass

    def test_download_genome_annotation_package(self) -> None:
        """Test case for download_genome_annotation_package

        Get an annotation report dataset by accession
        """
        pass

    def test_download_genome_annotation_package_by_post(self) -> None:
        """Test case for download_genome_annotation_package_by_post

        Get an annotation report dataset by accession
        """
        pass

    def test_genome_annotation_download_summary(self) -> None:
        """Test case for genome_annotation_download_summary

        Preview feature dataset download
        """
        pass

    def test_genome_annotation_download_summary_by_post(self) -> None:
        """Test case for genome_annotation_download_summary_by_post

        Preview feature download by POST
        """
        pass

    def test_genome_annotation_report(self) -> None:
        """Test case for genome_annotation_report

        Get genome annotation reports by genome accession
        """
        pass

    def test_genome_annotation_report_by_post(self) -> None:
        """Test case for genome_annotation_report_by_post

        Get genome annotation reports by genome accession
        """
        pass

    def test_genome_dataset_report(self) -> None:
        """Test case for genome_dataset_report

        Get dataset reports by accessions
        """
        pass

    def test_genome_dataset_report_by_post(self) -> None:
        """Test case for genome_dataset_report_by_post

        Get dataset reports by accessions
        """
        pass

    def test_genome_dataset_reports_by_assembly_name(self) -> None:
        """Test case for genome_dataset_reports_by_assembly_name

        Get dataset reports by assembly name (exact)
        """
        pass

    def test_genome_dataset_reports_by_bioproject(self) -> None:
        """Test case for genome_dataset_reports_by_bioproject

        Get dataset reports by bioproject
        """
        pass

    def test_genome_dataset_reports_by_biosample_id(self) -> None:
        """Test case for genome_dataset_reports_by_biosample_id

        Get dataset reports by biosample id
        """
        pass

    def test_genome_dataset_reports_by_taxon(self) -> None:
        """Test case for genome_dataset_reports_by_taxon

        Get dataset reports by taxons
        """
        pass

    def test_genome_dataset_reports_by_wgs(self) -> None:
        """Test case for genome_dataset_reports_by_wgs

        Get dataset reports by wgs accession
        """
        pass

    def test_genome_download_summary(self) -> None:
        """Test case for genome_download_summary

        Preview genome dataset download
        """
        pass

    def test_genome_download_summary_by_post(self) -> None:
        """Test case for genome_download_summary_by_post

        Preview genome dataset download by POST
        """
        pass

    def test_genome_links_by_accession(self) -> None:
        """Test case for genome_links_by_accession

        Get assembly links by accessions
        """
        pass

    def test_genome_links_by_accession_by_post(self) -> None:
        """Test case for genome_links_by_accession_by_post

        Get assembly links by accessions
        """
        pass

    def test_genome_sequence_report(self) -> None:
        """Test case for genome_sequence_report

        Get sequence reports by accessions
        """
        pass

    def test_genome_sequence_report_by_post(self) -> None:
        """Test case for genome_sequence_report_by_post

        Get sequence reports by accessions
        """
        pass


if __name__ == '__main__':
    unittest.main()
