# coding: utf-8

"""
    NCBI Datasets API

    ### NCBI Datasets is a resource that lets you easily gather data from NCBI. The Datasets version 2 API is still in alpha, and we're updating it often to add new functionality, iron out bugs and enhance usability. For some larger downloads, you may want to download a [dehydrated zip archive](https://www.ncbi.nlm.nih.gov/datasets/docs/v2/how-tos/genomes/large-download/), and retrieve the individual data files at a later time. 

    The version of the OpenAPI document: v2
    Contact: help@ncbi.nlm.nih.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from ncbi.datasets.openapi.api.taxonomy_api import TaxonomyApi


class TestTaxonomyApi(unittest.TestCase):
    """TaxonomyApi unit test stubs"""

    def setUp(self) -> None:
        self.api = TaxonomyApi()

    def tearDown(self) -> None:
        pass

    def test_download_taxonomy_package(self) -> None:
        """Test case for download_taxonomy_package

        Get a taxonomy data package by tax ID
        """
        pass

    def test_download_taxonomy_package_by_post(self) -> None:
        """Test case for download_taxonomy_package_by_post

        Get a taxonomy data package by tax_id
        """
        pass

    def test_tax_name_query(self) -> None:
        """Test case for tax_name_query

        Get a list of taxonomy names and IDs given a partial taxonomic name
        """
        pass

    def test_tax_name_query_by_post(self) -> None:
        """Test case for tax_name_query_by_post

        Get a list of taxonomy names and IDs given a partial taxonomic name
        """
        pass

    def test_taxonomy_data_report(self) -> None:
        """Test case for taxonomy_data_report

        Use taxonomic identifiers to get taxonomic data report
        """
        pass

    def test_taxonomy_data_report_post(self) -> None:
        """Test case for taxonomy_data_report_post

        Use taxonomic identifiers to get taxonomic names data report by post
        """
        pass

    def test_taxonomy_filtered_subtree(self) -> None:
        """Test case for taxonomy_filtered_subtree

        Use taxonomic identifiers to get a filtered taxonomic subtree
        """
        pass

    def test_taxonomy_filtered_subtree_post(self) -> None:
        """Test case for taxonomy_filtered_subtree_post

        Use taxonomic identifiers to get a filtered taxonomic subtree by post
        """
        pass

    def test_taxonomy_image(self) -> None:
        """Test case for taxonomy_image

        Retrieve image associated with a taxonomic identifier
        """
        pass

    def test_taxonomy_image_metadata(self) -> None:
        """Test case for taxonomy_image_metadata

        Retrieve image metadata associated with a taxonomic identifier
        """
        pass

    def test_taxonomy_image_metadata_post(self) -> None:
        """Test case for taxonomy_image_metadata_post

        Retrieve image metadata associated with a taxonomic identifier by post
        """
        pass

    def test_taxonomy_image_post(self) -> None:
        """Test case for taxonomy_image_post

        Retrieve image associated with a taxonomic identifier by post
        """
        pass

    def test_taxonomy_links(self) -> None:
        """Test case for taxonomy_links

        Retrieve external links associated with a taxonomic identifier.
        """
        pass

    def test_taxonomy_links_by_post(self) -> None:
        """Test case for taxonomy_links_by_post

        Retrieve external links associated with a taxonomic identifier.
        """
        pass

    def test_taxonomy_metadata(self) -> None:
        """Test case for taxonomy_metadata

        Use taxonomic identifiers to get taxonomic metadata
        """
        pass

    def test_taxonomy_metadata_post(self) -> None:
        """Test case for taxonomy_metadata_post

        Use taxonomic identifiers to get taxonomic metadata by post
        """
        pass

    def test_taxonomy_names(self) -> None:
        """Test case for taxonomy_names

        Use taxonomic identifiers to get taxonomic names data report
        """
        pass

    def test_taxonomy_names_post(self) -> None:
        """Test case for taxonomy_names_post

        Use taxonomic identifiers to get taxonomic names data report by post
        """
        pass

    def test_taxonomy_related_ids(self) -> None:
        """Test case for taxonomy_related_ids

        Use taxonomic identifier to get related taxonomic identifiers, such as children
        """
        pass

    def test_taxonomy_related_ids_post(self) -> None:
        """Test case for taxonomy_related_ids_post

        Use taxonomic identifier to get related taxonomic identifiers, such as children
        """
        pass


if __name__ == '__main__':
    unittest.main()
